package org.jayasoft.ivyde.eclipse.cpcontainer;


import org.eclipse.core.runtime.CoreException;
import org.eclipse.core.runtime.IPath;
import org.eclipse.jdt.core.ClasspathContainerInitializer;
import org.eclipse.jdt.core.IClasspathContainer;
import org.eclipse.jdt.core.IJavaProject;
import org.eclipse.jdt.core.JavaCore;
import org.eclipse.jdt.core.JavaModelException;

/**
 *
 */
public class IvyClasspathInitializer extends ClasspathContainerInitializer {

	/* (non-Javadoc)
	 * @see org.eclipse.jdt.core.ClasspathContainerInitializer#initialize(org.eclipse.core.runtime.IPath, org.eclipse.jdt.core.IJavaProject)
	 */
	public void initialize(IPath containerPath, IJavaProject project) throws CoreException {
        if (IvyClasspathContainer.isIvyClasspathContainer(containerPath)) {
    	    try {
                String ivyFilePath = IvyClasspathContainer.getIvyFilePath(containerPath);
                String[] confs = IvyClasspathContainer.getConfigurations(containerPath);
                IClasspathContainer ivyClasspathContainer = (IClasspathContainer)JavaCore.getClasspathContainer(containerPath, project);
                if (!(ivyClasspathContainer instanceof IvyClasspathContainer)) {
                    ivyClasspathContainer = new IvyClasspathContainer( project, containerPath, ivyFilePath, confs );
                }
                JavaCore.setClasspathContainer(containerPath, new IJavaProject[] { project },   new IClasspathContainer[] { ivyClasspathContainer }, null);
            } catch (JavaModelException e) {
                e.printStackTrace();
            }
        }
	}



    /* (non-Javadoc)
	 * @see org.eclipse.jdt.core.ClasspathContainerInitializer#canUpdateClasspathContainer(org.eclipse.core.runtime.IPath, org.eclipse.jdt.core.IJavaProject)
	 */
	public boolean canUpdateClasspathContainer(IPath containerPath, IJavaProject project) {
		return true;
	}

	/**
	 * @see org.eclipse.jdt.core.ClasspathContainerInitializer#requestClasspathContainerUpdate(org.eclipse.core.runtime.IPath, org.eclipse.jdt.core.IJavaProject, org.eclipse.jdt.core.IClasspathContainer)
	 */
	public void requestClasspathContainerUpdate(IPath containerPath, IJavaProject project, IClasspathContainer containerSuggestion) throws CoreException {
//		if (isUserLibraryContainer(containerPath)) {
//			String name= containerPath.segment(1);
//			if (containerSuggestion != null) {
//				UserLibrary library= new UserLibrary(containerSuggestion.getClasspathEntries(), containerSuggestion.getKind() == IClasspathContainer.K_SYSTEM);
//				UserLibraryManager.setUserLibrary(name, library, null); // should use a real progress monitor
//			} else {
//				UserLibraryManager.setUserLibrary(name, null, null); // should use a real progress monitor
//			}
//		}
	    toString();
	}

	/**
	 * @see org.eclipse.jdt.core.ClasspathContainerInitializer#getDescription(org.eclipse.core.runtime.IPath, org.eclipse.jdt.core.IJavaProject)
	 */
	public String getDescription(IPath containerPath, IJavaProject project) {
		return "my description";
	}

	/* (non-Javadoc)
	 * @see org.eclipse.jdt.core.ClasspathContainerInitializer#getComparisonID(org.eclipse.core.runtime.IPath, org.eclipse.jdt.core.IJavaProject)
	 */
	public Object getComparisonID(IPath containerPath, IJavaProject project) {
		return containerPath;
	}
}


